class ErrorCode:
    DEFAULT_INTERNAL_ERROR = 13000000

    ATTRIBUTES_NOT_SET = 23001001
    MODEL_PROJECT_CREATE_ERROR = 23001002
    MODEL_PROJECT_DELETE_ERROR = 23001003
    MODEL_VERSION_CREATE_ERROR = 23001004
    MODEL_VERSION_DELETE_ERROR = 23001005
    PACKAGE_UPLOAD_ERROR = 23001006
    MODEL_UPLOAD_ERROR = 23001007
    JOB_CREATE_ERROR = 23001008
    JOB_GET_STATUS_ERROR = 23001009
    JOB_STOP_ERROR = 23001010
    TOOLBOX_DEPLOY_ERROR = 23001011
    TOOLBOX_GET_DEPLOY_STATUS_ERROR = 23001012
    TOOLBOX_UNDEPLOY_ERROR = 23001013
    SERVE_DEPLOY_ERROR = 23001014
    SERVE_GET_DEPLOY_STATUS_ERROR = 23001015
    SERVE_UNDEPLOY_ERROR = 23001016
    DIRECTORY_HINT_ERROR = 23001017
    FILE_HINT_ERROR = 23001018
    PATH_EXIST_HINT_ERROR = 23001019
    RELATIVE_PATH_HINT_ERROR = 23001020
    LIST_MODELS_ERROR = 23001021
    GET_MODEL_ERROR = 23001022
    ARGS_FORMAT_ERROR = 23001023
    GET_ENV_ERROR = 23001024
    HTTP_REQUEST_ERROR = 23001025
    NOT_SUPPORT_SAVE_MODEL = 23001026


class ErrorMessage:
    UNAUTHORIZED = "未授权或者个人token失效，请先调用 aie.Authenticate() 进行授权"
    ATTRIBUTES_NOT_SET = "属性未设置"
    MODEL_PROJECT_CREATE_ERROR = "模型项目创建失败"
    MODEL_PROJECT_DELETE_ERROR = "模型项目删除失败"
    MODEL_VERSION_CREATE_ERROR = "模型版本创建失败"
    MODEL_VERSION_DELETE_ERROR = "模型版本删除失败"
    PACKAGE_UPLOAD_ERROR = "代码上传失败"
    MODEL_UPLOAD_ERROR = "模型上传失败"
    JOB_CREATE_ERROR = "[任务]创建失败"
    JOB_GET_STATUS_ERROR = "[任务]状态获取失败"
    JOB_STOP_ERROR = "[任务]停止失败"
    TOOLBOX_DEPLOY_ERROR = "[工具箱]模型部署失败"
    TOOLBOX_GET_DEPLOY_STATUS_ERROR = "[工具箱]模型部署状态获取失败"
    TOOLBOX_UNDEPLOY_ERROR = "[工具箱]模型取消部署失败"
    SERVE_DEPLOY_ERROR = "[在线服务]模型部署失败"
    SERVE_GET_DEPLOY_STATUS_ERROR = "[在线服务]模型部署状态获取失败"
    SERVE_UNDEPLOY_ERROR = "[在线服务]模型取消部署失败"
    DIRECTORY_HINT_ERROR = "参数应为目录"
    FILE_HINT_ERROR = "参数应为文件"
    PATH_EXIST_HINT_ERROR = "路径不存在"
    RELATIVE_PATH_HINT_ERROR = "参数应为相对路径"
    LIST_MODELS_ERROR = "获取模型列表失败"
    GET_MODEL_ERROR = "获取模型失败"
    ARGS_FORMAT_ERROR = "参数格式错误"
    GET_ENV_ERROR = "获取环境变量失败"
    HTTP_REQUEST_ERROR = "HTTP请求失败"
    NOT_SUPPORT_SAVE_MODEL = "不支持模型保存"
